<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

/*
 * Copyright 2011 (c) Mario Damianus
 * For SpitzerGlobal 
 * Mischa Project (CMS)
 * Authentication Controller
 */

final class File extends MY_Controller 
{
	
	private $cc_id;
	private $upload_path;
	private $view 		 = array();
	private $file 		 = array();
	private $upload_data = array();
	
	// Constructor
	public function __construct()
	{
		parent::__construct();
	}
	
	private function get_dir_path()
	{ 		
		switch ($this->cc_id) 
		{
			case 1:$this->upload_path = './../images/slide/';break;
			case 2:$this->upload_path = './../images/gallery/full/';break;
			case 3:$this->upload_path = './../images/about/';break;
			case 4:$this->upload_path = './../images/event/photo/';break;
		}
	}
	
	private function get_dir2_path()
	{ 		
		switch ($this->cc_id) 
		{
			case 1:$this->upload_path = './../images/slide/';break;
			case 2:$this->upload_path = './../images/gallery/thumbnails/';break;
			case 3:$this->upload_path = './../images/about/';break;
			case 4:$this->upload_path = './../images/event/thumb/';break;
		}
	}
	
	private function _crop($image)
	{
		list($width, $height, $type, $attr) = getimagesize($this->upload_path.$image);
		$config['image_library'] 	= 'gd2';
		$config['source_image'] 	= $this->upload_path.$image;
		$config['new_image'] 		= './../images/gallery/crop/'.$image;
		$config['create_thumb'] 	= FALSE;
		$config['maintain_ratio'] 	= FALSE;
		
		
		if($width <= $height)
		{
			$config['x_axis'] = 0;
			$config['y_axis'] = ($height - $width) / 2;
			$height = $width;
		}
		else
		{
			$config['x_axis'] = ($width - $height) / 2;
			$config['y_axis'] = 0;
			$width = $height;			
		}
		
		$config['width']  = $width;
		$config['height'] = $height;
		

		$this->image_lib->initialize($config);

		$this->image_lib->crop();
		
		$this->image_lib->clear();
		
		
	}
	
	function _resize($image)
	{

		$config['image_library'] 	= 'gd2';
		$config['source_image'] 	= './../images/gallery/crop/'.$image;
		$config['create_thumb'] 	= FALSE;
		$config['maintain_ratio'] 	= FALSE;
		$config['width'] 			= 200;
		$config['height'] 			= 200;

		$this->image_lib->initialize($config);

		$this->image_lib->resize();
		
		$this->image_lib->clear();
	}
	
	private function do_resize($file_name)
	{
		$config['image_library'] = 'gd2';
		$config['create_thumb'] = TRUE;
		$config['maintain_ratio'] = TRUE;
		
		switch ($this->cc_id) 
		{
			case 2: 
				   $config['source_image'] = './../images/gallery/full/'.$file_name;
				   $config['new_image']    = './../images/gallery/photos/'.$file_name;
				   $config['width']  = 800;
				   $config['height'] = 400;
				   $this->image_lib->initialize($config);		   
				   $this->image_lib->resize();
				   
				   $this->image_lib->clear();
				   
				   $config['source_image'] = './../images/gallery/full/'.$file_name;
				   $config['new_image']    = './../images/gallery/thumbnails/'.$file_name;
				   $config['width']  = 200;
				   $config['height'] = 75;
				   $this->image_lib->initialize($config);		   
				   $this->image_lib->resize();
				   
				   break;
				   
			case 4:$config['source_image'] = './../images/event/photo/'.$file_name;
				   $config['new_image']    = './../images/event/thumb/'.$file_name;
				   $config['width']  = 200;
				   $config['height'] = 200;
				   $this->image_lib->initialize($config);
				   $this->image_lib->resize();
				   
				   break;
		}
	}
	
	public function uploadify($cc_id = null)
	{
		$file = $this->input->post('filearray');
		$this->cc_id = $cc_id;
		$this->get_dir_path();
		
		$this->_crop($file);
		$this->_resize($file);
		$this->do_resize($file);						
		
		$this->model_file->insert(
			$file,
			$this->cc_id
		);
	}
	
	// method index
	public function index($cc_id = null)
	{			
		// upload file
		if($_POST)
		{
			/*
			$this->cc_id = $cc_id;
			
			if (!empty($_FILES)) 
			{
				$fileName = $_FILES['Filedata']['name'];
				$tempFile = $_FILES['Filedata']['tmp_name'];
				list($width, $height, $type, $attr) = getimagesize($tempFile);
				
				$this->get_dir_path();
					
				//$config['upload_path']   = $this->upload_path;
				//$config['allowed_types'] = '*';
				//$config['max_size']	     = '2048';
				
				//$this->upload->initialize($config);
				
				if(move_uploaded_file($tempFile,$this->upload_path)) {
						
					$this->_crop($fileName,$width,$height);
					$this->_resize($fileName);
					$this->do_resize($fileName);						
					
					$this->model_file->insert(
						$fileName,
						$this->cc_id
					);
				}
			}
			*/
			/*
			foreach($_FILES as $key => $value)
			{
				if(!empty($value['name']))
				{
					$this->get_dir_path();
					
					$config['upload_path']   = $this->upload_path;
					$config['allowed_types'] = '*';
					$config['max_size']	     = '2048';
					$this->upload->initialize($config);
					
					if(file_exists($this->upload_path.$value['name']))
					{
						$this->session->set_flashdata('upload_error',$value['name'].' already exists');
						redirect('file');
					}
					else if($this->upload->do_upload($key))
					{
						
						$uploaded = $this->upload->data();
						
						$this->_crop($uploaded['file_name'],$uploaded['image_width'],$uploaded['image_height']);
						$this->_resize($uploaded['file_name']);
						$this->do_resize($uploaded['file_name']);						
						
						$this->upload_data = $this->upload->data();																		$this->session->set_flashdata('upload_error','Upload Success');						
						$this->model_file->insert(
							$this->upload_data['file_name'],
							$this->cc_id
						);

					} else {
						$this->session->set_flashdata('upload_error',$this->upload->display_errors());
						redirect('file');
					}
				}
			}
			*/
			//redirect('file');
			
		}
		else
		{
			$this->cc_id = $this->input->get('cc_id');
			if(!is_null($this->cc_id) AND !empty($this->cc_id))
				$this->view['cc_id'] = $this->cc_id;
			else 
				$this->view['cc_id'] = 1;
			$this->layout->view('file/index',$this->view);
		}
	}
	
	public function delete_file_from_folder($cc_id,$file_id)
	{
		
		$file = $this->model_file->read_file_by_file_id($file_id);
		
		switch($cc_id)
		{
			case 1:if(file_exists('./../images/slide/'.$file->file_path))
						unlink('./../images/slide/'.$file->file_path);
				   break;
			case 2:if(file_exists('./../images/gallery/full/'.$file->file_path) AND file_exists('./../images/gallery/photos/'.$file->file_path) AND file_exists('./../images/gallery/thumbnails/'.$file->file_path))
				   {
						unlink('./../images/gallery/full/'.$file->file_path);
						unlink('./../images/gallery/photos/'.$file->file_path);
						unlink('./../images/gallery/thumbnails/'.$file->file_path);
						unlink('./../images/gallery/crop/'.$file->file_path);
				   }
				   break;
			case 3:if(file_exists('./../images/about/'.$file->file_path))
						unlink('./../images/about/'.$file->file_path);
				   break;
			case 4:if(file_exists('./../images/event/photo/'.$file->file_path) AND file_exists('./../images/event/thumb/'.$file->file_path))
				   {
						unlink('./../images/event/photo/'.$file->file_path);
						unlink('./../images/event/thumb/'.$file->file_path);
				   }	
				   break;
		}
	}
	
	public function partial($action = null, $cc_id = null, $file_id = null, $page = null)
	{
		if($this->input->is_ajax_request())
		{
			if(md5('all') == $action)
			{
				$this->show_all($cc_id,$page);
			}
			else if(md5('delete') == $action)
			{
				if($this->model_file->check_file($cc_id,$file_id))
				{
					$this->delete_file_from_folder($cc_id,$file_id);
					$this->model_file->delete($file_id);
					$this->show_all($cc_id,$page);
				}
				else 
				{
					echo '<p>File is currently in use</p>';
				}
				
			}
			else if(md5('multiple') == $action)
			{
				$this->show_multiple($cc_id,$page);
			}
			else if(md5('multipleevent') == $action)
			{
				$this->show_multiple_by_event($cc_id,$file_id);
			}
			else 
			{
				exit('No direct access allowed');
			}
		} 
		else 
		{
			exit('No direct access allowed');
		}
	}
	
	private function show_all($cc_id,$page)
	{
		$this->cc_id = $cc_id;
		$this->get_dir2_path();
				
		$this->view['file_path'] = str_replace('./../', '/', $this->upload_path); 		
		$this->view['row']       = $this->model_file->read_file_list_by_ccid_num_row($this->cc_id);
		$this->view['list_file'] = $this->model_file->read_file_list_by_ccid($this->cc_id,$page);
		$this->load->view('file/list',$this->view);
	}
	
	private function show_multiple($cc_id,$page)
	{
		$this->cc_id = $cc_id;
		$this->get_dir2_path();
				
		$this->view['file_path'] = str_replace('./../', '/', $this->upload_path); 		
		$this->view['row']       = $this->model_file->read_file_list_by_ccid_num_row($this->cc_id);
		$this->view['list_file'] = $this->model_file->read_file_list_by_ccid($this->cc_id,$page);
		$this->load->view('file/multiple',$this->view);
	}
	
	private function show_multiple_by_event($cc_id,$ev_id)
	{
		$page = null;
		
		$this->cc_id = $cc_id;
		$this->get_dir2_path();
				
		$this->view['file_path'] = str_replace('./../', '/', $this->upload_path); 		
		$this->view['current']   = $this->model_file->read_current_event_file($ev_id);
		$this->view['row']       = $this->model_file->read_file_list_by_ccid_num_row($this->cc_id);
		$this->view['list_file'] = $this->model_file->read_file_list_by_ccid($this->cc_id,$page);
		$this->load->view('file/multiple2',$this->view);
	}
	
}

/* End of file file */
/* Location: ./application/controllers/file.php */