<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Model_event extends CI_Model {
	
	private $res;
	
	public function __construct() 
	{
		parent::__construct();
	}
	
	public function read_event_num_row()
	{
		$this->res = $this->db->get_where('event');
		return $this->res->num_rows();
	}
	
	public function read_event_row($ev_id)
	{
		$this->res = $this->db->get_where('event',array('ev_id' => $ev_id));
		return $this->res->row();
	}
	
	public function read_event($offset,$per_page)
	{
		$this->res = $this->db
							  //->limit($per_page)
							  //->offset($offset)
							  ->get('event');
							  
		return $this->res->result();
	}
	
	public function update($ev_id,$title,$des,$date)
	{
		$this->db->where('ev_id',$ev_id)
			     ->update('event',
			array(
				'ev_title' => $title,
				'ev_des'   => $des,
				'ev_date'  => $date
			)
		);
	}
	
	public function insert($title,$des,$date)
	{
		$this->db->insert('event',
			array(
				'ev_title' => $title,
				'ev_des'   => $des,
				'ev_date'  => $date
			)
		);
	}
	
	public function delete_detail($ev_id)
	{
		$this->db->where('ev_id',$ev_id)->delete('event_detail');
	}
	
	public function insert_detail($ev_id,$file_id)
	{
		$this->db->insert('event_detail',
			array(
				'ev_id'   => $ev_id,
				'file_id'  => $file_id
			)
		);
	}
	
	public function delete($ev_id)
	{
		$this->db->where('ev_id',$ev_id)
			     ->delete('event');
	}
	
}