<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Model_file extends CI_Model {
	
	private $res;
	private $row;
	
	public function __construct() 
	{
		parent::__construct();
	}
	
	public function read_file_by_file_id($file_id)
	{
		$this->res = $this->db->get_where('file',array('file_id' => $file_id));
		return $this->res->row();
	}
	
	public function read_file_list_by_ccid($cc_id,$page)
	{
		$this->res = $this->db->get_where('file',array('cc_id' => $cc_id));
		return $this->res->result();
	}
	
	public function read_file_list_by_ccid_num_row($cc_id)
	{
		$this->res = $this->db->get_where('file',array('cc_id' => $cc_id));
		return $this->res->result();
	}
	
	public function read_current_event_file($ev_id)
	{
		$this->res = $this->db->get_where('event_detail',array('ev_id' => $ev_id));
		return $this->res->result();
	}
	
	public function insert($file,$cc_id)
	{
		$this->db->insert('file',
			array(
				'file_path'    => $file,
				'cc_id'	       => $cc_id,
				'file_type_id' => 1
			)
		);
	}
	
	public function delete($file_id)
	{
		$this->db->where('file_id',$file_id)
				 ->delete('file');
	}
	
	public function check_file($cc_id,$file_id)
	{		
		
		$result = FALSE;
	
		switch($cc_id)
		{
			case 1:$this->res = $this->db->get_where('content',array('file_id' => $file_id, 'cc_id' => $cc_id));
				   $this->res = $this->res->num_rows();
				   $result = $this->res > 0 ? FALSE : TRUE;
				   break;
			case 2:$this->res = $this->db->get_where('gallery',array('file_id' => $file_id));
				   $this->res = $this->res->num_rows();
				   $result = $this->res > 0 ? FALSE : TRUE;
				   break;
			case 3:$this->res = $this->db->get_where('content',array('file_id' => $file_id, 'cc_id' => $cc_id));
				   $this->res = $this->res->num_rows();
				   $result = $this->res > 0 ? FALSE : TRUE;
				   break;
			case 4:$this->res = $this->db->get_where('event_detail',array('file_id' => $file_id));
				   $this->res = $this->res->num_rows();
				   $result = $this->res > 0 ? FALSE : TRUE;
				   break;
		}
		
		return $result;
		
	}
	
}